#!/usr/bin/perl

########################################
#                                      #
#          Mitsu-Uroko bbs 2           #
#          index.cgi ver.1.11          #
#                                      #
#       Last modify : 05/05/10         #
#                                      #
#     This script is written by KL     #
#                                      #
########################################


require 'bbs_conf.pl';
use CGI;


#----------#
#   Perl   #
#----------#

#-----<subroutine>-----#
#---make HTML
sub htmlc {
	my($title, $fileloc) = @_;
	
	open(LOG, "./log/".$fileloc.".log");
	@outFile = <LOG>;
	close(LOG);
	unlink("./log/".$fileloc.".log");
	
	open(HTML, ">./html/".$fileloc.".html");
	select HTML;#---set out to HTML
	
	#---HTML head
	print "<html>\n<head>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n";
	print "<title>".$title."</title>\n";
	print "<link href=\"../bbs.css\" rel=\"stylesheet\" type=\"text/css\">\n</head>\n\n<body>\n";
	print "<table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"7\" bordercolor=\"\#CCCCCC\" bgcolor=\"\#efefef\">\n";
	print "<tr><td>\n<font size=\"+1\">".$title."</font><br>\n";
	
	#---HTML cntents
	my$i=0;
	for (; $i<=$#outFile; $i++) {
		my($name, $mail, $date, $id, $message) = split(/\t/, $outFile[$i]);
		if ($mail ne "") {$name = "<a href=\"mailto:".$mail."\">".$name."</a>";}
		else {$name = "<span class=\"nomail\">".$name."</span>";}
		print (($i+1)."@<font color=\"\#666666\">OF</font>".$name."@<font color=\"\#666666\">eF</font>".$date."@<font color=\"\#666666\">IDF</font>".$id."<br>\n");
		$message =~ s/https?\:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+/<a href=\"$&\" target=\"_blank\">$&<\/a>/g;
		print "<blockquote>".$message."</blockquote><br>\n";
	}
	
	#---HTML tail
	print "</p>\n</blockquote>\n</td></tr>\n</table>\n</body>\n</html>\n";
	
	select STDOUT;#---set out to STDOUT
	close(HTML);
}



#---dat out
sub datout {
	&fileLock("LISTLOCK");#lock
	
	my$write_flag = 0;

	open(F, "list.dat");
	flock(F, 2);
	my@list = <F>;
	flock(F, 8);
	close(F);
	
	my$i=0;
	for (; $i<=$#list; $i++) {
		my@tmp = split(/\t/, $list[$i]);
		chomp($tmp[4]);#---get thread status
		my$difTime = $times-$tmp[3];#---get time difference
		if ((($tmp[4] eq "full") && ($difTime > $time_FULL)) || ($difTime > $time_OLD)) {#---save to HTML
			&htmlc($tmp[1], $tmp[2]);#---make HTML log
			$list[$i] = "";
			unlink("./log/".$tmp[2].".log");
			$write_flag = 1;
		} elsif (($tmp[4] eq "stop") && ($difTime > $time_STOP)) {#---void(stop log)
			$list[$i] = "";
			unlink("./log/".$tmp[2].".log");
			$write_flag = 1;
		}
	}
	
	if ($write_flag == 1) {
		open(F, ">list.dat");
		flock(F, 2);
		print F @list;
		flock(F, 8);
		close(F);
	}
	
	&fileUnLock("LISTLOCK");#unlock
}

#---edit run.dat
sub edit {
	&fileLock("RUNLOCK");#lock

	open(F, "run.dat");
	flock(F, 2);
	my@list = <F>;
	flock(F, 8);
	close(F);
	
	my$i=0;
	for (; $i<=$#list; $i++) {
		my@tmp = split(/\t/, $list[$i]);
		chomp($tmp[2]);
		if (($a = $times-$tmp[1]) > $time_RUN) {
			$tmp[2]--;
			if ($tmp[2]>0) {
				$tmp[1] += $time_RUN;
				$list[$i] = $tmp[0]."\t".$tmp[1]."\t".$tmp[2]."\n";
			} else {
				$list[$i] = "";
			}
		}
	}
	
	open(F, ">run.dat");
	flock(F, 2);
	print F @list;
	flock(F, 8);
	close(F);
	
	&fileUnLock("RUNLOCK");#unlock
}

#---make thread list
sub filelist {
	my$mode = @_[0];
	
	open(F, "list.dat");
	flock(F, 2);
	@list = <F>;
	flock(F, 8);
	close(F);
	
	print "<p>\n<table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"7\" bordercolor=\"\#CCCCCC\" bgcolor=\"\#efefef\">\n";
	if ($mode eq "all") {
		print "<tr><td>\n<div align=\"left\">Xbhꗗ\n<blockquote>\n";
		for ($i=0; $i<=$#list; $i++) {
			my@tmp = split(/\t/, $list[$i]);
			print "<a href=\"read.cgi?key=".$tmp[2]."/\">".$tmp[1]."(".$tmp[0].")</a><br>\n";
		}
		print "</blockquote>\n</div>\n</tr></td>\n</table>\n</p>\n";
	} else {
		print "<tr><td>\n<div align=\"left\">VXbhꗗ\n<blockquote>\n";
		for ($i=0; $i<=4 && $#list>=$i; $i++) {
			my@tmp = split(/\t/, $list[$i]);
			print "<a href=\"\#".$i."\">".$tmp[1]."(".$tmp[0].")</a><br>\n";
		}
		for ($i=5; $i<=$mode && $#list>=$i; $i++) {
			my@tmp = split(/\t/, $list[$i]);
			print "<a href=\"read.cgi?key=".$tmp[2]."/\">".$tmp[1]."(".$tmp[0].")</a><br>\n";
		}
		print "</blockquote>\n</div>\n";
		print "<div align=\"right\"><a href=\"html/index.cgi?mode=0\">ߋOꗗ</a>@<a href=\"./index.cgi?mode=list\">Xbhꗗ</a></div>\n";
		print "</tr></td>\n</table>\n</p>\n";
	}
}

#---make thread digest
sub digest {
	my$i = @_[0]-1;
	
	if ($i != 0) {&digest($i)}
	
	my@tmp = split(/\t/, $list[$i]);
	chomp($tmp[4]);
	
	open(F, "./log/".$tmp[2].".log");
	flock(F, 2);
	my@data = <F>;
	flock(F, 8);
	close(F);
	
	#---table head
	print "<p>\n<a name=\"".$i."\"></a>\n";
	print "<table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"7\" bordercolor=\"\#CCCCCC\" bgcolor=\"\#efefef\">\n";
	print "<tr>\n<td>\n";
	print "<font size=\"+1\">".$tmp[1]."</font><br>\n";
	
	#---table contents
	&printer($data[0]);
	for ($i=$tmp[0]-5; $i<$tmp[0]; $i++) {
		if ($i > 0) {&printer($data[$i], $i)};
	}
	
	#---table tail
	print "<blockquote>\n";
	if ($tmp[4] eq "null") {#---input form
		print "<form name=\"form1\" method=\"post\" action=\"./write.cgi\">\n";
		print "<input type=\"submit\" name=\"Submit\" value=\"\"><input type=\"hidden\" name=\"key\" value=\"".$tmp[2]."\">\n";
		print "O:<input name=\"name\" type=\"text\" id=\"name\" size=\"19\"".$myname.">\n";
		print "mail:<input name=\"mail\" type=\"text\" id=\"mail\" size=\"19\">\n";
		print "݂:<input name=\"omikuji\" type=\"checkbox\" id=\"omikuji\" value=\"on\"".$checked.">\n";
		print "<ul><textarea name=\"message\" cols=\"65\" rows=\"5\" wrap=\"OFF\" id=\"message\"></textarea></ul>\n";
		print "</form>\n";
	}
	
	#---jumpper
	print "<p>\n<a href=\"./read.cgi?key=".$tmp[2]."/\">[S]</a>@\n";
	print "<a href=\"./read.cgi?key=".$tmp[2]."/l10\">[ŐV10]</a>@\n";
	print "<a href=\"./read.cgi?key=".$tmp[2]."/1-10\">[ŏ]</a>\n</p>\n";
	
	print "</blockquote>\n</td></tr>\n</table>\n</p>\n";
}
sub printer {
	my@tmp = split(/\t/, @_[0]);
	my$i = @_[1]+1;
	
	if ($tmp[1] ne "") {$tmp[0] = "<a href=\"mailto:".$tmp[1]."\">".$tmp[0]."</a>";}
	else {$tmp[0] = "<span class=\"nomail\">".$tmp[0]."</span>";}
	print $i."@<font color=\"\#666666\">OF</font>".$tmp[0]."@<font color=\"\#666666\">eF</font>".$tmp[2]."@<font color=\"\#666666\">IDF</font>".$tmp[3]."<br>\n";
	$tmp[4] =~ s/https?\:\/\/[\w\.\~\-\/\?\&\+\=\:\@\%\;\#\%]+/<a href=\"$&\" target=\"_blank\">$&<\/a>/g;
	print "<blockquote>".$tmp[4]."</blockquote><br>\n";
}

#---print Attention
sub attention {
	if ($attention ne "") {
		print "<p>\n";
		print "<table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"7\" bordercolor=\"#CCCCCC\" bgcolor=\"#efefef\">\n";
		print "<tr><td>\n";
		
		print $attention;
		
		print "</tr></td>\n";
		print "</table>\n";
		print "</p>\n";
	}
}

#---bbs top image ramdom selector
sub top_image {
	opendir(DIR, "./img/");
	my@imgs = readdir DIR;
	closedir(DIR);
	my@result;

	foreach $line (@imgs) {
		if (($line =~ /\.jpg+/g) || ($line =~ /\.gif+/g)) {
			unshift @result, $line;
		}
	}
	
	return $result[int(rand($#result+1))];
}

#---file lock by dir		&fileLock(dir_name);
sub fileLock {
	my$dirName = @_[0];

	while (1 != mkdir("./$dirName", 666)) {#---lock
		select(undef, undef, undef, 0.01);
		$rockCount++;
		if ($rockCount > 1000) {rmdir("./$dirName");}
	}
}

#---file unlock by dir		&fileUnLock(dir_name);
sub fileUnLock {
		my$dirName = @_[0];

		rmdir("./$dirName");
}

#---show a link to mobile mode	&go_mobile;
sub go_mobile {
	if ($use_mobile_mode == 1) {
		print "<p align=\"left\"><a href=\"./m.cgi\">[gїp]</a></p>";
	}
}

#--------<main>--------#

#---init---
$times = time;

#---from HTML---
$q = new CGI;
$mode = $q->param('mode');

#---set cookie---
$cookie = $ENV{'HTTP_COOKIE'};
@cookie = split(/; /, $cookie);
($myname, $checked) = ("", "");
foreach $tmp (@cookie) {
	($cKey, $cVal) = split(/=/, $tmp);
	if ($cKey eq 'myname' && $cVal ne "") {$myname = " value=\"".$cVal."\"";}
	elsif ($cKey eq 'myomikuji' && $cVal eq "on") {$checked = " checked";}
}



#----------#
#   HTML   #
#----------#

#---HTML head---
print "Content-type: text/html \n\n";

print "<html>\n<head>\n";
print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n";
print "<title>".$bbs_name."</title>\n<link href=\"bbs.css\" rel=\"stylesheet\" type=\"text/css\">\n";
print "</head>\n\n<body>\n";
&go_mobile;
print "<p align=\"center\"><img src=\"./img/".&top_image."\" width=\"400\" height=\"100\"></p>\n";

if ($mode eq "list") {
	&filelist("all");#---list
} else {
	&datout;#---edit list.dat
	&edit;#---edit run.dat
	
	#---attention
	&attention;
	
	&filelist(10);#---list(open list.dat here!)
	
	if ($#list>-1) {&digest(($#list>4?5:$#list+1))};
}

#---HTML tail
print "<p><table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"7\" bordercolor=\"\#CCCCCC\" bgcolor=\"\#efefef\">\n";
print "<tr><td>\n<div align=\"center\">VKXbh쐬</div>\n<blockquote>\n";
print "<form action=\"./write.cgi\" method=\"post\" name=\"new\">\n";
print "薼:<input name=\"title\" type=\"text\" size=\"50\"><input name=\"key\" type=\"hidden\" value=\"new\"><br>\n";
print "O:<input name=\"name\" type=\"text\" size=\"19\" ".$myname."\">\n";
print "mail:<input name=\"mail\" type=\"text\" size=\"19\">\n";
print "݂:<input name=\"omikuji\" type=\"checkbox\" value=\"on\"".$checked."\">\n";
print "<ul><textarea name=\"message\" cols=\"65\" rows=\"5\"></textarea></ul>\n";
print "<ul><input type=\"submit\" name=\"Submit2\" value=\"VK쐬\"></ul>\n";
print "</form>\n</blockquote>\n</td></tr>\n</table>\n</p>\n";

print "</body>\n</html>\n";

exit;

